//------------------------------------------------------
// Name: Polynom.cpp
// Desc: polinom kezelsre szolgl osztly
// (c) RebelMaGE, 2004
//------------------------------------------------------
#include "Polynom.h"
//------------------------------------------------------
// Name: Polynom
// Desc: konstruktor
//------------------------------------------------------
Polynom::Polynom(const int fokszam){
	m_fokszam = fokszam;
	m_polynom = new float[fokszam + 1];
	for (int i = 0; i <fokszam + 1; i++){
		cout << "x^" << i << " * ";
		cin >> m_polynom[i];
	}
}
//------------------------------------------------------
// Name: Polynom
// Desc: kopi konstruktor
//------------------------------------------------------
Polynom::Polynom(const Polynom& p){
	m_fokszam = p.m_fokszam;
	m_polynom = new float[m_fokszam + 1];
	for (int i = 0; i <= m_fokszam; i++){
		m_polynom[i] = p.m_polynom[i];
	}
}
//------------------------------------------------------
// Name: Polynom
// Desc: konstruktor, demonstrcis
//------------------------------------------------------
Polynom::Polynom(const char a){
	switch (a) {
		case 'a':{

			m_fokszam = 5;
			m_polynom = new float[6];

			m_polynom[0] = 0.9f; // * x^0
			m_polynom[1] = 1.0f; // * x^1
			m_polynom[2] = 2.1f; // * x^2
			m_polynom[3] = 0.0f; // * x^3
			m_polynom[4] = 4.2f; // * x^4				
			m_polynom[5] = 5.0f; // * x^5

			break;
		}
		case 'b':

			m_fokszam = 3;
			m_polynom = new float[4];

			m_polynom[0] = -.9f; // * x^0
			m_polynom[1] = 0.0f; // * x^1
			m_polynom[2] = 2.1f; // * x^2
			m_polynom[3] = 9.0f; // * x^3
			
			break;

		default:
			m_fokszam = 0;
			m_polynom = NULL;		
	}
}
//------------------------------------------------------
// Name: Polynom
// Desc: konstruktor
//------------------------------------------------------
Polynom::Polynom(){
	m_fokszam = 0;
	m_polynom = NULL;
}
//------------------------------------------------------
// Name: ~Polynom
// Desc: destruktor
//------------------------------------------------------
Polynom::~Polynom(){
	if(m_polynom) delete m_polynom;
	m_polynom = NULL;

}
//------------------------------------------------------
// Name: operator+
// Desc: sszeads
//------------------------------------------------------
Polynom Polynom::operator+(const Polynom& p){
	Polynom retVal;
	retVal.m_fokszam = (m_fokszam > p.m_fokszam)?m_fokszam : p.m_fokszam;
	retVal.m_polynom = new float[retVal.m_fokszam + 1];
	for( int i = 0; 
		i < ((m_fokszam < p.m_fokszam)?m_fokszam : p.m_fokszam);
		i++){

		retVal.m_polynom[i] = m_polynom[i] + p.m_polynom[i];
	}
	if (m_fokszam > p.m_fokszam){
		for (int i = p.m_fokszam; i <= m_fokszam; i++)
			retVal.m_polynom[i] = m_polynom[i];
	}
	if (m_fokszam < p.m_fokszam){
		for (int i = m_fokszam; i <= p.m_fokszam; i++)
			retVal.m_polynom[i] = p.m_polynom[i];
	}

	return retVal;

}
//------------------------------------------------------
// Name: operator-
// Desc: lehetne rajta mg szpteni de egyelre megtesz
//------------------------------------------------------
Polynom Polynom::operator-(const Polynom& p){

	Polynom retVal;
	retVal.m_fokszam = (m_fokszam > p.m_fokszam)?m_fokszam : p.m_fokszam;
	retVal.m_polynom = new float[retVal.m_fokszam + 1];
	for( int i = 0; 
		i <= ((m_fokszam < p.m_fokszam)?m_fokszam : p.m_fokszam);
		i++){

		retVal.m_polynom[i] = m_polynom[i] - p.m_polynom[i];
	}
	if (m_fokszam > p.m_fokszam){
		for (int i = p.m_fokszam; i <= m_fokszam; i++)
			retVal.m_polynom[i] = m_polynom[i];
	}
	if (m_fokszam < p.m_fokszam){
		for (int i = m_fokszam; i <= p.m_fokszam; i++)
			retVal.m_polynom[i] = -p.m_polynom[i];
	}

	return retVal;

}

//------------------------------------------------------
// Name: operator*
// Desc: szorzs konstanssal
//------------------------------------------------------
Polynom Polynom::operator*(const float c){

	Polynom retVal;
	retVal.m_fokszam = m_fokszam;
	retVal.m_polynom = new float[m_fokszam + 1];

	for (int i = 0; i <= m_fokszam; i++){
		retVal.m_polynom[i] = m_polynom[i] * c;
	}

	return retVal;

}

//------------------------------------------------------
// Name: evaluate
// Desc: kirtkels
//------------------------------------------------------
float Polynom::evaluate(float x){

	float sum = 0;

	for (int i = 0; i <= m_fokszam; i++){
		sum += (m_polynom[i] * pow(x,i));
	}

	return sum;

}
//------------------------------------------------------
// Name: operator <<
// Desc: friend, kiirats
//------------------------------------------------------
ostream& operator<<(ostream& out, Polynom& p){
	if( p.m_fokszam > 0 /*&& 0.0f != p.m_polynom[p.m_fokszam]*/) 
		cout << p.m_polynom[p.m_fokszam] << " * x^" << p.m_fokszam;
	for (int i = p.m_fokszam - 1; i >= 0 ; i--){
		//if ( 0.0f == p.m_polynom[i])
		//	continue;
		//else
		if ( i == 0)
			cout << " + " << p.m_polynom[i];
		else				
		if ( i == 1)
			cout << " + " << p.m_polynom[i] << " * x" ;
		else
			cout << " + " << p.m_polynom[i] << " * x^" << i;
	}
	return out;
}