//------------------------------------------------------
// Name: StringSet.cpp
// Desc: sztringhalmaz kezelsre szolgl osztly
// (c) 2004
//------------------------------------------------------
#include "StringSet.h"
//------------------------------------------------------
// Name: StringSet
// Desc: konstruktor. a len nek semmi jelentssge
//		 ez klnbzteti meg a msik konstruktortl
//------------------------------------------------------
StringSet::StringSet(int len){
	m_num = 0;
	m_strings = NULL;
}
//------------------------------------------------------
// Name: StringSet
// Desc: konstruktor
//------------------------------------------------------
StringSet::StringSet(char** strings, short num){
	m_strings = new char*[num];
	m_num = num;
	for (int i = 0; i < num; i++){
		m_strings[i] = new char[strlen(strings[i] + 1)];
		strcpy(m_strings[i], strings[i]);
	}
}
//------------------------------------------------------
// Name: StringSet
// Desc: (taln) ez a faladat szerinti hivatalos konstru
//------------------------------------------------------
StringSet::StringSet(){
	short num = 0;		
	cout << "rja be a sztringek szmt (1<=szm<=5):";
	cin >> num;
	m_num = num;
	m_strings = new char*[num];
	for (int i = 0; i < num; i++){
		m_strings[i] = new char[256];
		cout << i << ": ";
//			scanf("%s", m_strings[i]);
		cin >> m_strings[i];
	}

	//for (int i = 0; i < num; i++){
	//	//m_strings[i] = new char[256];
	//	cout << i << ": " << m_strings[i] << std::endl;
	//}
	//int a;
	//cin >> a;
}
//------------------------------------------------------
// Name: StringSet
// Desc: kopi konstruktor
//------------------------------------------------------
StringSet::StringSet(StringSet& sset){
	for (short i = 0; i < sset.m_num; i++){
		m_num = i;
		add(sset.m_strings[i]);
	}
}
//------------------------------------------------------
// Name: ~StringSet
// Desc: destruktor
//------------------------------------------------------
StringSet::~StringSet(){
//		cout << endl << this << " destructed (" << m_num << ")";
	for (int i = 0;i < m_num; i++){
//			cout << endl << "\t" << m_strings[i];
		if (m_strings[i]) delete m_strings[i];
	}
	if (m_strings) delete m_strings;
	m_strings = NULL;

//		cout << endl;
}
//------------------------------------------------------
// Name: in
// Desc: a kapott sztring eleme az osztlyban trolt
//		 halmaznak
//------------------------------------------------------
int StringSet::in(const char* str){
	for (int i = 0; i < m_num; i++){
		if(!strcmp(m_strings[i], str)) return 1;
	}
	return 0;
}
//------------------------------------------------------
// Name: add
// Desc: hozzadja a stringet a halmazhoz
//------------------------------------------------------
void StringSet::add(const char* str){
	if (in(str)) return;
	char** temp = new char*[m_num + 1];
	for(int i = 0; i < m_num; i++){
		temp[i] = m_strings[i];
	}
	if (!m_strings) delete m_strings; // csak a tmbt sznteti meg (remlem)
	temp[m_num] = new char[strlen(str) + 1];
	strcpy(temp[m_num],str);
	m_strings = temp;
	m_num++;
}
//------------------------------------------------------
// Name: operator+
// Desc: ni megvalstsa
//------------------------------------------------------
StringSet StringSet::operator+(const StringSet sset){
	StringSet retVal(0);
	
	//cout << "empty:" << endl << retVal << endl;
	//cout << "this:" << endl;
	//for (int i = 0; i < m_num; i++){			
	//	cout << i << ": " << m_strings[i] << endl;
	//}
	//cout << "rightop:" << endl << sset;

	for (int i = 0; i < sset.m_num; i++){
		retVal.add(sset.m_strings[i]);
	}
	for (int j = 0; j < m_num; j++){
		retVal.add(m_strings[j]);
	}
	//cout << retVal;
	return retVal;
}
//------------------------------------------------------
// Name: operator*
// Desc: metszet megvalstsa
//------------------------------------------------------
StringSet StringSet::operator*(const StringSet sset){
	StringSet retVal(0);
	
	for (int i = 0; i < sset.m_num; i++){
		if (in(sset.m_strings[i]))
			retVal.add(sset.m_strings[i]);
	}

	return retVal;
}
//------------------------------------------------------
// Name: operator-
// Desc: klnbsg megvalstsa
//------------------------------------------------------
StringSet StringSet::operator-(StringSet sset){
	StringSet retVal(0);
	
	for (int i = 0; i < m_num; i++){
		if (!sset.in(m_strings[i]))
			retVal.add(m_strings[i]);
	}

	return retVal;
}
//------------------------------------------------------
// Name: operator^
// Desc: szimmetrikus klnbsg megvalstsa
//------------------------------------------------------
StringSet StringSet::operator^(StringSet sset){
	StringSet retVal(0);

	for (int i = 0; i < m_num; i++){
		if (!sset.in(m_strings[i]))
			retVal.add(m_strings[i]);
	}
		// bal oldal

	for (int j = 0; j < sset.m_num; j++){
		if (!in(sset.m_strings[j]))
			retVal.add(sset.m_strings[j]);
	}
		// jobb oldal

	return retVal;
}
//------------------------------------------------------
// Name: operator<<
// Desc: kir friend member
//------------------------------------------------------
ostream& operator <<(ostream& out, const StringSet& strset){
	out << endl;
	for (int i = 0; i < strset.m_num; i++){
		out << i << ": " << strset.m_strings[i] << std::endl;
	}
	return out;
}